
#Toolchain
CROSS_COMPILE  ?= arm-none-eabi
CC  = gcc
AS  = as
LD  = gcc
AR  = ar
NM  = nm
STRIP   = strip
SIZE    = size
OBJCOPY = objcopy
OBJDUMP = objdump
RANLIB  = ranlib

ifdef CROSS_COMPILE
CC:=$(CROSS_COMPILE)-$(CC)
AS:=$(CROSS_COMPILE)-$(AS)
LD:=$(CROSS_COMPILE)-$(LD)
AR:=$(CROSS_COMPILE)-$(AR)
NM:=$(CROSS_COMPILE)-$(NM)
STRIP:=$(CROSS_COMPILE)-$(STRIP)
SIZE:=$(CROSS_COMPILE)-$(SIZE)
OBJCOPY:=$(CROSS_COMPILE)-$(OBJCOPY)
OBJDUMP:=$(CROSS_COMPILE)-$(OBJDUMP)
endif
COMPONENTS_BASE_DIR   = $(SDK_BASE_DIR)/middleware/wireless/zigbee
#ZIGBEE_BASE_SRC : c source file dir
ZIGBEE_BASE_SRC = $(SDK_BASE_DIR)/components/osa:\
                  $(SDK_BASE_DIR)/components/messaging:\
                  $(SDK_BASE_DIR)/middleware/multicore/rpmsg_lite/lib/rpmsg_lite/porting/platform/k32w1:\
                  $(SDK_BASE_DIR)/components/reset:\
                  $(SDK_BASE_DIR)/components/power_manager/core:\
                  $(SDK_BASE_DIR)/devices/K32W1480:\
                  $(SDK_BASE_DIR)/middleware/wireless/framework/FunctionLib:\
                  $(SDK_BASE_DIR)/components/serial_manager:\
                  $(SDK_BASE_DIR)/devices/K32W1480/utilities/str:\
                  $(SDK_BASE_DIR)/components/timer_manager:\
                  $(SDK_BASE_DIR)/middleware/wireless/framework/RNG:\
                  $(SDK_BASE_DIR)/middleware/wireless/XCVR/drv/nb2p4ghz:\
                  $(SDK_BASE_DIR)/middleware/wireless/framework/ModuleInfo:\
                  $(SDK_BASE_DIR)/middleware/wireless/framework/NVM/source:\
                  $(SDK_BASE_DIR)/components/timer:\
                  $(SDK_BASE_DIR)/components/led:\
                  $(SDK_BASE_DIR)/middleware/multicore/rpmsg_lite/lib/virtio:\
                  $(SDK_BASE_DIR)/components/time_stamp:\
                  $(SDK_BASE_DIR)/middleware/secure-subsystem/src/sscp:\
                  $(SDK_BASE_DIR)/devices/K32W1480/utilities/format:\
                  $(SDK_BASE_DIR)/components/power_manager/boards/K32W148-EVK:\
                  $(SDK_BASE_DIR)/components/internal_flash:\
                  $(SDK_BASE_DIR)/middleware/wireless/framework/HWParameter:\
                  $(SDK_BASE_DIR)/components/mem_manager:\
                  $(SDK_BASE_DIR)/middleware/multicore/mcmgr/src/:\
                  $(SDK_BASE_DIR)/middleware/multicore/rpmsg_lite/lib/rpmsg_lite/porting/environment:\
                  $(SDK_BASE_DIR)/middleware/wireless/XCVR/drv:\
                  $(SDK_BASE_DIR)/components/button:\
                  $(SDK_BASE_DIR)/middleware/multicore/rpmsg_lite/lib/common:\
                  $(SDK_BASE_DIR)/middleware/multicore/rpmsg_lite/lib/rpmsg_lite:\
                  $(SDK_BASE_DIR)/components/lists:\
                  $(SDK_BASE_DIR)/components/uart:\
                  $(SDK_BASE_DIR)/devices/K32W1480/utilities/debug_console_lite:\
                  $(SDK_BASE_DIR)/middleware/wireless/framework/Platform/kw45_k32w1:\
                  $(SDK_BASE_DIR)/components/common_task:\
                  $(SDK_BASE_DIR)/middleware/wireless/XCVR/drv/nb2p4ghz/configs/gen45:\
                  $(SDK_BASE_DIR)/devices/K32W1480/gcc:\
                  $(SDK_BASE_DIR)/middleware/wireless/framework/SecLib:\
                  $(SDK_BASE_DIR)/middleware/wireless/framework/Sensors:\
                  $(SDK_BASE_DIR)/components/panic:\
                  $(SDK_BASE_DIR)/middleware/secure-subsystem/port/kw45_k4w1:\
                  $(SDK_BASE_DIR)/devices/K32W1480/drivers:\
                  $(SDK_BASE_DIR)/components/rpmsg:\
				  $(SDK_BASE_DIR)/middleware/wireless/framework/OtaSupport/Source:\
				  $(SDK_BASE_DIR)/middleware/wireless/zigbee/platform/K32W1/framework/PWRM:\
				  $(SDK_BASE_DIR)/middleware/wireless/zigbee/platform/K32W1/platform:\
				  $(SDK_BASE_DIR)/middleware/wireless/zigbee/platform/K32W1/framework/SecLib:\
				  $(SDK_BASE_DIR)/middleware/wireless/framework/LowPower:\
				  $(SDK_BASE_DIR)/middleware/wireless/zigbee/platform/K32W1/framework\PDM:\
				  $(SDK_BASE_DIR)/middleware/wireless/framework/boards/kw45_k32w1:\
                  $(SDK_BASE_DIR)/devices/K32W1480/utilities:\
                  $(SDK_BASE_DIR)/middleware/wireless/framework/boards/kw45_k32w1/K32W1480:\
				  $(SDK_BASE_DIR)/middleware/wireless/zigbee/ZigbeeCommon/Source

#APPSRC : c source file
APPSRC += newLib.c
APPSRC += nxp_xcvr_mode_config.c
APPSRC += sss_hmac_sha256.c
APPSRC += nxp_xcvr_coding_config.c
APPSRC += nxp_xcvr_gfsk_bt_0p5_h_0p7_config.c
APPSRC += fsl_component_mem_manager_light.c
APPSRC += fsl_edma.c
APPSRC += PWRM_adapter.c
APPSRC += sss_ecdh.c
APPSRC += HWParameter.c
APPSRC += fsl_lptmr.c
APPSRC += rpmsg_env_bm.c
APPSRC += fwk_platform.c
APPSRC += fsl_common_arm.c
APPSRC += mathfp.c
APPSRC += sss_aes.c
APPSRC += glue.c
APPSRC += FunctionLib.c
APPSRC += fsl_sss_mgmt.c
APPSRC += sss_sha256.c
APPSRC += fsl_adapter_lptmr_time_stamp.c
APPSRC += fsl_lpuart.c
APPSRC += fsl_adapter_reset.c
APPSRC += nxp_xcvr_lcl_ctrl.c
APPSRC += fsl_assert.c
APPSRC += fsl_sss_sscp.c
APPSRC += NV_Flash.c
APPSRC += fsl_adapter_k4_flash.c
APPSRC += fsl_pm_board.c
APPSRC += nxp_xcvr_ext_ctrl.c
APPSRC += nxp2p4_xcvr.c
APPSRC += rpmsg_ns.c
APPSRC += fsl_k4_flash.c
APPSRC += fsl_vref.c
APPSRC += fsl_str.c
APPSRC += fsl_common.c
APPSRC += fsl_imu.c
APPSRC += nxp_xcvr_oqpsk_802p15p4_config.c
APPSRC += fsl_component_led.c
APPSRC += SecLib_sss.c
APPSRC += fsl_component_generic_list.c
APPSRC += fsl_component_common_task.c
APPSRC += fsl_tpm.c
APPSRC += nxp_xcvr_gfsk_bt_0p5_h_1p0_config.c
APPSRC += fsl_clock.c
APPSRC += nxp_xcvr_trim.c
APPSRC += fsl_gpio.c
APPSRC += fsl_elemu.c
APPSRC += fsl_pm_core.c
APPSRC += fsl_wdog32.c
APPSRC += fsl_component_serial_port_uart.c
APPSRC += mcmgr.c
APPSRC += rpmsg_platform.c
APPSRC += fsl_k4_controller.c
APPSRC += ModuleInfo.c
APPSRC += fsl_component_messaging.c
APPSRC += virtqueue.c
APPSRC += fsl_format.c
APPSRC += nxp_xcvr_gfsk_bt_0p5_h_0p5_config.c
APPSRC += fsl_wuu.c
APPSRC += fsl_ccm32k.c
APPSRC += sensors.c
APPSRC += dbg_ram_capture.c
APPSRC += fsl_spc.c
APPSRC += llist.c
APPSRC += fsl_adapter_rpmsg.c
APPSRC += mcmgr_imu_internal.c
APPSRC += nxp_xcvr_lcl_config.c
APPSRC += fwk_platform_ics.c
APPSRC += sss_aes_cmac.c
APPSRC += fsl_ltc.c
APPSRC += rpmsg_lite.c
APPSRC += fsl_component_serial_manager.c
APPSRC += aes_mmo.c
APPSRC += sss_init.c
APPSRC += fsl_component_serial_port_rpmsg.c
APPSRC += fsl_component_button.c
APPSRC += fsl_lpspi.c
APPSRC += nxp_xcvr_common_config.c
APPSRC += dma_capture.c
APPSRC += fsl_lpit.c
APPSRC += mcmgr_internal_core_api_k32w1.c
APPSRC += system_K32W1480.c
APPSRC += fsl_crc.c
APPSRC += fsl_adapter_lptmr.c
APPSRC += startup_K32W1480.S
APPSRC += fwk_platform_sensors.c
APPSRC += fsl_sscp_mu.c
APPSRC += rfmc_ctrl.c
APPSRC += fsl_component_panic.c
APPSRC += RNG.c
APPSRC += sss_ccm.c
APPSRC += fsl_lpadc.c
APPSRC += fsl_component_timer_manager.c
APPSRC += fsl_debug_console.c
APPSRC += nxp_xcvr_msk_config.c
APPSRC += PWR.c
APPSRC += SecLib_.c
APPSRC += fsl_adapter_lpuart.c
APPSRC += nxp_xcvr_gfsk_bt_0p5_h_0p32_config.c
APPSRC += PDM_adapter.c
APPSRC += fsl_lpuart_edma.c
APPSRC += fsl_cmc.c
APPSRC += timer.c
APPSRC += wdog.c

#OTA SRC
APPSRC += OtaSupport.c
APPSRC += OtaInternalFlash.c
APPSRC += fwk_platform_ota.c
APPSRC += fwk_platform_ot.c

#INCFLAGS : header file dir
INCFLAGS += -I$(SDK_BASE_DIR)/components/internal_flash
INCFLAGS += -I$(SDK_BASE_DIR)/middleware/multicore/rpmsg_lite/lib/include/platform/k32w1
INCFLAGS += -I$(SDK_BASE_DIR)/middleware/wireless/framework/Platform/kw45_k32w1
INCFLAGS += -I$(SDK_BASE_DIR)/middleware/wireless/framework/LowPower
INCFLAGS += -I$(SDK_BASE_DIR)/middleware/wireless/ieee-802.15.4/ieee_802_15_4/phy/interface
INCFLAGS += -I$(SDK_BASE_DIR)/middleware/wireless/framework/RNG
INCFLAGS += -I$(SDK_BASE_DIR)/middleware/wireless/framework/SecLib
INCFLAGS += -I$(SDK_BASE_DIR)/middleware/wireless/framework/Platform/kw45_k32w1/configs
INCFLAGS += -I$(SDK_BASE_DIR)/devices/K32W1480
INCFLAGS += -I$(SDK_BASE_DIR)/devices/K32W1480/utilities
INCFLAGS += -I$(SDK_BASE_DIR)/components/lists
INCFLAGS += -I$(SDK_BASE_DIR)/components/mem_manager
INCFLAGS += -I$(SDK_BASE_DIR)/CMSIS/Core/Include
INCFLAGS += -I$(SDK_BASE_DIR)/middleware/wireless/framework/SFC
INCFLAGS += -I$(SDK_BASE_DIR)/components/timer
INCFLAGS += -I$(SDK_BASE_DIR)/middleware/wireless/framework/PDUM/Include
INCFLAGS += -I$(SDK_BASE_DIR)/middleware/wireless/framework/Sensors
INCFLAGS += -I$(SDK_BASE_DIR)/middleware/multicore/rpmsg_lite/lib/include
INCFLAGS += -I$(SDK_BASE_DIR)/middleware/multicore/rpmsg_lite/lib/include/environment/bm
INCFLAGS += -I$(SDK_BASE_DIR)/devices/K32W1480/utilities/debug_console_lite
INCFLAGS += -I$(SDK_BASE_DIR)/middleware/wireless/framework/HWParameter
INCFLAGS += -I$(SDK_BASE_DIR)/components/serial_manager
INCFLAGS += -I$(SDK_BASE_DIR)/middleware/wireless/XCVR/drv/nb2p4ghz
INCFLAGS += -I$(SDK_BASE_DIR)/components/messaging
INCFLAGS += -I$(SDK_BASE_DIR)/middleware/wireless/framework/PDM/Include
INCFLAGS += -I$(SDK_BASE_DIR)/components/power_manager/boards/K32W148-EVK
INCFLAGS += -I$(SDK_BASE_DIR)/components/time_stamp
INCFLAGS += -I$(SDK_BASE_DIR)/components/button
INCFLAGS += -I$(SDK_BASE_DIR)/components/timer_manager
INCFLAGS += -I$(SDK_BASE_DIR)/components/uart
INCFLAGS += -I$(SDK_BASE_DIR)/devices/K32W1480/utilities/format
INCFLAGS += -I$(SDK_BASE_DIR)/middleware/wireless/XCVR/drv/nb2p4ghz/configs/gen45
INCFLAGS += -I$(SDK_BASE_DIR)/middleware/wireless/framework/DBG
INCFLAGS += -I$(SDK_BASE_DIR)/components/led
INCFLAGS += -I$(SDK_BASE_DIR)/components/gpio
INCFLAGS += -I$(SDK_BASE_DIR)/middleware/wireless/framework/ModuleInfo
INCFLAGS += -I$(SDK_BASE_DIR)/middleware/wireless/ieee-802.15.4/Include
INCFLAGS += -I$(SDK_BASE_DIR)/components/reset
INCFLAGS += -I$(SDK_BASE_DIR)/middleware/wireless/XCVR/drv/
INCFLAGS += -I$(SDK_BASE_DIR)/devices/K32W1480/drivers
INCFLAGS += -I$(SDK_BASE_DIR)/components/panic
INCFLAGS += -I$(SDK_BASE_DIR)/middleware/wireless/framework/NVM/source
INCFLAGS += -I$(SDK_BASE_DIR)/components/rpmsg
INCFLAGS += -I$(SDK_BASE_DIR)/components/power_manager/core
INCFLAGS += -I$(SDK_BASE_DIR)/middleware/wireless/framework/NVM/interface
INCFLAGS += -I$(SDK_BASE_DIR)/middleware/multicore/mcmgr/src
INCFLAGS += -I$(SDK_BASE_DIR)/devices/K32W1480/utilities/str
INCFLAGS += -I$(SDK_BASE_DIR)/components/osa
INCFLAGS += -I$(SDK_BASE_DIR)/middleware/secure-subsystem/inc
INCFLAGS += -I$(SDK_BASE_DIR)/middleware/secure-subsystem/inc/elemu
INCFLAGS += -I$(SDK_BASE_DIR)/middleware/wireless/framework/FunctionLib
INCFLAGS += -I$(SDK_BASE_DIR)/middleware/wireless/framework/Common
INCFLAGS += -I$(SDK_BASE_DIR)/middleware/secure-subsystem/port/kw45_k4w1
INCFLAGS += -I$(SDK_BASE_DIR)/components/common_task
INCFLAGS += -I$(SDK_BASE_DIR)/middleware/wireless/zigbee/platform
INCFLAGS += -I$(SDK_BASE_DIR)/middleware/wireless/zigbee/platform
INCFLAGS += -I$(SDK_BASE_DIR)/middleware/wireless/zigbee/platform/K32W1/framework/PWRM/Include
INCFLAGS += -I$(SDK_BASE_DIR)/middleware/wireless/zigbee/platform/K32W1/framework/RNG/Interface
INCFLAGS += -I$(SDK_BASE_DIR)/middleware/wireless/zigbee/platform/K32W1/framework/Common
INCFLAGS += -I$(SDK_BASE_DIR)/middleware/wireless/zigbee/platform/K32W1/framework/SecLib
INCFLAGS += -I$(SDK_BASE_DIR)/middleware/wireless/framework/boards/kw45_k32w1/K32W1480

#OTA inlude
INCFLAGS += -I$(SDK_BASE_DIR)/middleware/wireless/framework/OtaSupport/Interface
INCFLAGS += -I$(SDK_BASE_DIR)/middleware/wireless/framework/platform/include
INCFLAGS += -I$(SDK_BASE_DIR)/middleware/wireless/framework/boards/kw45_k32w1
INCFLAGS += -I$(SDK_BASE_DIR)/middleware/wireless/framework/OtaSupport/Source

INCFLAGS += -Os -fno-common -g -mcpu=cortex-m33 -c -ffunction-sections -fdata-sections -ffreestanding -fno-builtin -mcpu=cortex-m33 -mfpu=fpv5-sp-d16 -mfloat-abi=hard -mthumb -D__NEWLIB__ -fstack-usage -MMD -MP
#LDLIBS : extra SDK lib
LDLIBS += ZPSGP ZPSIPAN _crypto_m33 ieee-802.15.4_split

#LDFLAGS : SDK lib path
LDFLAGS += -L$(SDK_BASE_DIR)"/middleware/wireless/zigbee/platform/K32W1/libs"
LDFLAGS += -L$(SDK_BASE_DIR)"/middleware/wireless/framework/SecLib"
LDFLAGS += -L$(SDK_BASE_DIR)"/middleware/wireless/framework/PDUM/Library"
LDFLAGS += -L$(SDK_BASE_DIR)"/middleware/wireless/framework/Common/devices/kw45_k32w1/gcc"
LDFLAGS += -L$(SDK_BASE_DIR)"/middleware/wireless/ieee-802.15.4/ieee_802_15_4/lib"

#CFLAGS: Defined Symbol
CFLAGS += -std=gnu99
CFLAGS += -DWATCHDOG_ALLOWED
CFLAGS += -DCPU_K32W1480VFTA
CFLAGS += -DCPU_K32W1480VFTA_cm33
CFLAGS += -DFSL_OSA_MAIN_FUNC_ENABLE=1
CFLAGS += -DGENERIC_LIST_LIGHT=0
CFLAGS += -DUSE_SMU2_AS_SYSTEM_MEMORY=1
CFLAGS += -DHAL_RPMSG_SELECT_ROLE=0
CFLAGS += -DUSE_NBU=1
CFLAGS += -DgRngUseSecureSubSystem_d=1
CFLAGS += -DSSS_CONFIG_FILE='"fsl_sss_config_elemu.h"'
CFLAGS += -DSSCP_CONFIG_FILE='"fsl_sscp_config_elemu.h"'
CFLAGS += -DgMemManagerLightGuardsCheckEnable=1
CFLAGS += -DgMemManagerLightExtendHeapAreaUsage=1
CFLAGS += -DgNvStorageIncluded_d=1
CFLAGS += -DUSE_PB_RAM_AS_SYSTEM_MEMORY=1
CFLAGS += -DgDebugConsoleEnable_d=1
CFLAGS += -DDebugConsole_c=1
CFLAGS += -DFSL_OSA_TASK_ENABLE=1
CFLAGS += -DSDK_OS_BAREMETAL
CFLAGS += -DSERIAL_PORT_TYPE_UART=1
CFLAGS += -DSDK_DEBUGCONSOLE=1
CFLAGS += -DRouter
CFLAGS += -DPRINTF_ADVANCED_ENABLE=1
CFLAGS += -DZBPRO_DEVICE_TYPE=ZCR
CFLAGS += -DcPWR_FullPowerDownMode=1
CFLAGS += -DHEAP_SIZE=4000
CFLAGS += -DLITTLE_ENDIAN_PROCESSOR
CFLAGS += -DNDEBUG
CFLAGS += -Dvector_table_size=512
CFLAGS += -D__ram_vector_table__=1
CFLAGS += -DosNumberOfSemaphores=0
CFLAGS += -DosNumberOfMutexes=0
CFLAGS += -DosNumberOfMessageQs=0
CFLAGS += -DosNumberOfMessages=0
CFLAGS += -DgMainThreadStackSize_c=0
CFLAGS += -DgMainThreadPriority_c=7
CFLAGS += -DgTaskMultipleInstancesManagement_c=0
CFLAGS += -DFSL_OSA_BM_TIMER_CONFIG=FSL_OSA_BM_TIMER_SYSTICK
CFLAGS += -DENABLE_RAM_VECTOR_TABLE
CFLAGS += -DgFlashEraseDuringWrite=0
CFLAGS += -DgInvalidateHeaderLength=336
CFLAGS += -DgEepromType_d=gEepromDevice_InternalFlash_c
CFLAGS += -DgOtaVerifyWrite_d=0
CFLAGS += -DgEePromParams_BufferSize_c=512
CFLAGS += -DgEepromParams_bufferedWrite_c=1
CFLAGS += -DgEepromParams_CurrentOffset=0
CFLAGS += -DZIGBEE_USE_FRAMEWORK=1
CFLAGS += -DgSupportBle=0
CFLAGS += -DJN518x=5180
CFLAGS += -DJENNIC_CHIP_FAMILY_NAME=_JN518x
CFLAGS += -DJENNIC_CHIP_FAMILY=JN518x
CFLAGS += -DJENNIC_CHIP_FAMILY_JN518x
CFLAGS += -D__JN518X__
CFLAGS += -DPDM_NO_RTOS
CFLAGS += -DCPU_JN518X
CFLAGS += -D__NEWLIB__
CFLAGS += -DSERIAL_PORT_TYPE_RPMSG=1
CFLAGS += -DRF_OSC_26MHZ=0
CFLAGS += -DTEST_BUILD_COEX=0
CFLAGS += -DARM_MATH_CM3=1
CFLAGS += -DMCUXPRESSO_SDK
CFLAGS += -DDEBUG
CFLAGS += -DCR_INTEGER_PRINTF
CFLAGS += -D__MCUXPRESSO
CFLAGS += -D__USE_CMSIS

#PDM
CFLAGS += -DPDM_BUFFER_SIZE=3000

#LDFLAGS : linker flags
LDFLAGS += -Xlinker --sort-section=alignment
LDFLAGS += -Xlinker --gc-sections
LDFLAGS += -Xlinker -print-memory-usage
LDFLAGS += -Xlinker --defsym=__stack_size__=0x2000
LDFLAGS += -Xlinker --defsym=__heap_size__=0x8000
LDFLAGS += -Xlinker --defsym=gUseNVMLink_d=1

#OTA linker flag
LDFLAGS += -Xlinker --defsym=gUseInternalStorageLink_d=1

LDFLAGS += -Xlinker --cref
LDFLAGS += -mcpu=cortex-m33 -mfpu=fpv5-sp-d16 -mfloat-abi=hard -mthumb
#LDFLAGS += -Xlinker --no-warn-rwx-segments -Xlinker -no-warn-rwx-segments
