/*****************************************************************************
 * Copyright  2018 NXP
 * All rights reserved
 *

 * SPDX-License-Identifier: LA_OPT_BASE_LICENSE v24 May 2018
 *****************************************************************************/
/*****************************************************************************
 *
 * MODULE:             JN-AN-1257
 *
 * COMPONENT:          app_window_covering.h
 *
 * DESCRIPTION:        Window Covering application
 *
 ****************************************************************************
 *
 * This software is owned by NXP B.V. and/or its supplier and is protected
 * under applicable copyright laws. All rights are reserved. We grant You,
 * and any third parties, a license to use this software solely and
 * exclusively on NXP products [NXP Microcontrollers such as JN5168, JN5169,
 * JN5179, JN5189].
 * You, and any third parties must reproduce the copyright and warranty notice
 * and any other legend of ownership on each copy or partial copy of the
 * software.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Copyright NXP B.V. 2016-2019. All rights reserved
 *
 ***************************************************************************/

#ifndef APP_WINDOW_COVERING_H_
#define APP_WINDOW_COVERING_H_

#include "app_common.h"
#ifdef CLD_OTA
#include "OTA.h"
#endif

/****************************************************************************/
/***        Macro Definitions                                             ***/
/****************************************************************************/

/****************************************************************************/
/***        Type Definitions                                              ***/
/****************************************************************************/

/****************************************************************************/
/***        Exported Functions                                            ***/
/****************************************************************************/
PUBLIC void APP_vInitialiseRouter(void);
PUBLIC void APP_vFactoryResetRecords(void);
PUBLIC void APP_taskRouter(void);
PUBLIC void APP_vOobcSetRunning(void);
#ifdef CLD_OTA
PUBLIC teNodeState eGetNodeState(void);
PUBLIC tsOTA_PersistedData sGetOTACallBackPersistdata(void);
PUBLIC uint8 app_u8GetDeviceEndpoint(void);
#endif
PUBLIC void APP_vMotorInitialise(void);
PUBLIC void APP_vMotorForward(void);
PUBLIC void APP_vMotorBackward(void);
PUBLIC void APP_vMotorStop(void);
PUBLIC bool_t APP_bMotorGoToLiftValue(uint16 u16LiftValue);
PUBLIC bool_t APP_bMotorGoToLiftPercentage(uint8 u8LiftPercentage);
PUBLIC void APP_vMotorUpdateModeFromAttribute(void);
PUBLIC void APP_vMotorToggleModeBits(uint8 u8ModeMask);
PUBLIC void APP_vMotorClusterUpdate(void);
PUBLIC void APP_cbTimerMotor(void *pvParams);

/****************************************************************************/
/***        External Variables                                            ***/
/****************************************************************************/
extern PUBLIC tsDeviceDesc sDeviceDesc;

/****************************************************************************/
/****************************************************************************/
/****************************************************************************/

#endif /*APP_WINDOW_COVERING_H_ */
